import java.awt.*;

        // A non-visual component that uses a MediaTracker to monitor
        // image loading.
class ImageLoader extends Component {
        // Get the images.
    public Image[] retrieveImages(String[] files) {
        final int numImages = files.length;
        Image[] images = new Image[numImages];
        if(numImages > 0){
            // Use a Toolkit to load the images.
            Toolkit tk = Toolkit.getDefaultToolkit();
            // Use a MediaTracker to monitor the loading.
            MediaTracker tracker = new MediaTracker(this);
            for(int i = 0; i < numImages; i++){
                System.out.println("Loading: "+files[i]);
                images[i] = tk.getImage(files[i]);
                // Give each a separate ID for checking.
                tracker.addImage(images[i],i);
            }
            // Loading initiated, wait a limited time for them to arrive.
            try{
                final long waitingTime = 5*1000;
                tracker.waitForAll(waitingTime);
            }
            catch(InterruptedException e){
                System.out.println("Interrupted.");
            }
            System.out.println("Checking.");
            // Check each.
            for(int i = 0; i < numImages; i++){
                if(tracker.checkID(i)){
                    System.out.println("Loaded: "+files[i]);
                }
                else{
                    System.out.println("Failed to load: "+files[i]);
                    images[i] = null;
                }
            }
            if(tracker.isErrorAny()){
                System.out.println("There were errors.");
            }
        }
        return images;
    }
}
