class Dealer {
        // Create a new pack and distribute cards to the players.
    public void dealTheCards(){
        final Player[] players = getPlayers();
        int nextPlayer = 0;
        // Select the first player to receive a card.
        Player player = players[nextPlayer];

        // Distribute the cards until they run out.
        final Pack pack = new Pack();
        pack.shuffle();
        Card card = pack.nextCard();
        while(card != null){
            player.takeCard(card);
            // Calculate the index of the next player.
            nextPlayer = (nextPlayer+1) % numPlayers;
            player = players[nextPlayer];
            // Get the next card, if any.
            card = pack.nextCard();
        }
    }

        // The cards have been distributed; play a game.
    public void superviseAGame(){
        // Where to show the game.
        CardDisplay display = new CardDisplay(numPlayers);
        display.clear();

        final Player[] players = getPlayers();
        // Select the first player to play a card.
        int nextPlayer = 0;
        Player player = players[nextPlayer];

        // Create a pile for the first round.
        Pile pile = new Pile();
        // Request the first card of the round.
        Card cardPlayed = player.playCard();

        while(cardPlayed != null){
            display.showCard(cardPlayed,nextPlayer);
            // Add it to the pile.
            pile.addCard(cardPlayed);
            if(pile.snap()){
                display.report("Snap!"+
                               "Player: "+nextPlayer+" wins "+
                               pile.numCards()+" card(s).");
                display.clear();
                // player wins the cards in the pile.
                player.takePile(pile);
                // Create a new pile for the next round.
                pile = new Pile();
            }
            else{
                // Select the next player for this round.
                nextPlayer = (nextPlayer+1) % numPlayers;
                player = players[nextPlayer];
            }
            // Ask the player for the next card (if any).
            cardPlayed = player.playCard();
        }
        // Determine who has won.
        if(nextPlayer == 0){
            display.report("Player 1 has won.");
        }
        else{
            display.report("Player 0 has won.");
        }
    }

    private Player[] getPlayers(){
        return players;
    }

    // Setup the players.
    private static int numPlayers = 2;
    private final Player[] players = new Player[numPlayers];
    {
        for(int i = 0; i < numPlayers; i++){
            players[i] = new Player();
        }
    }
}
