import java.io.*;

    // Use a StringTokenizer to show the numbers present in all of the
    // files passed to showNumbers.
class NumberParser {
    public void showNumbers(String[] files){
        for(int n = 0; n < files.length; n++){
            try{
                FileReader inputFile = new FileReader(files[n]);
                BufferedReader reader = new BufferedReader(inputFile);

                System.out.println("Numbers in file: "+files[n]);
                parseNumbers(reader);
                reader.close();
            }
            catch(FileNotFoundException e){
                System.out.println("Unable to open "+files[n]);
            }
            catch(IOException e){
                System.out.println(e.getMessage());
            }
        }
    }

    // Use a StreamTokenizer to parse numbers from reader.
    private void parseNumbers(BufferedReader reader) 
            throws IOException {
        // Create a StreamTokenizer object to parse the numbers.
        StreamTokenizer stream = new StreamTokenizer(reader);
        while(stream.nextToken() != StreamTokenizer.TT_EOF){
            if(stream.ttype == StreamTokenizer.TT_NUMBER){
                // Print its value.
                System.out.println(stream.nval);
            }
            else{
                // Ignore any non-numerical data.
            }
        }
    }
}
