    // An interface for a simple (play-only) Video Cassette Recorder (VCR).
interface VCR {
    // All methods return true if successful,
    // or false otherwise - typically if there is no tape loaded.

        // Return false if a tape is already loaded.
    public boolean loadTape(String tapeName);
        // Return false if no tape is loaded.
    public boolean eject();
        // Main functions.
    public boolean play();
    public boolean pause();
    public boolean stop();
        // Fast-forward and rewind.
    public boolean ff();
    public boolean rew();
        // A method to inquire about the video's current status.
    public int getStatus();
        // Status inquiry values, returned by status().
    public static final int PLAYING = 0, PAUSED = 1, STOPPED = 2,
                            FORWARD = 3, BACKWARD = 4, NOTAPE = 5;
}
