    // Illustrate the creation and running of a simple thread.
    // Use an anonymous class for the thread.
public class AnonymousThreadExample {
    public static void main(String[] args){
        Thread secondThread = new Thread(){
            public void run(){
                final int max = 10;
                System.out.println("Started running.");
                for(int i = 1; i <= max; i++){
                    System.out.print(i+" ");
                }
                System.out.println();
                System.out.println("End of run reached.");
            }
        };

        if(!secondThread.isAlive()){
            System.out.println("Second thread is not yet alive.");
        }
        secondThread.start();
        if(secondThread.isAlive()){
            System.out.println("Second thread is now alive.");
        }
        // Let secondThread have a go.
        Thread.yield();
        if(!secondThread.isAlive()){
            System.out.println("Second thread is no longer alive.");
        }
        System.out.println("First thread has finished.");
    }
}
