class GroupCoordinator implements Runnable {
    public GroupCoordinator() {
        initCounters();
    }

        // Set up an array of threads to run multiple Counters.
    protected void initCounters(){
        // Where the threads are to be stored.
        Thread[] counters = getCounters();
        // The group for the counter threads.
        ThreadGroup group = getGroup();

        // Create the counters and threads.
        for(int i = 0; i < counters.length; i++){
            // Specify the range over which the counter operates.
            final int min = 10*i+1, max = min+9;
            // Place this thread in a ThreadGroup.
            counters[i] = new Thread(group,new FairCounter(min,max));
        }
        System.out.println("All counters created.");
    }

    public void run(){
        Thread[] counters = getCounters();

        for(int i = 0; i < counters.length; i++){
            counters[i].start();
        }

        System.out.println("All counters ready to run.");
        waitForCountersToFinish();
        System.out.println("All the threads have finished.");
    }

    protected void waitForCountersToFinish(){
        // The group to which the counters belong.
        ThreadGroup group = getGroup();
        do{
            try{
                Thread.sleep(500);
            }
            catch(InterruptedException e){
            }
        } while(group.activeCount() > 0);
    }

    protected Thread[] getCounters(){
        return counters;
    }

    protected ThreadGroup getGroup(){
        return counterGroup;
    }

    // Create the array to hold the threads.
    private final int numCounters = 3;
    private final Thread[] counters = new Thread[numCounters];
    // Create the group to hold the counter threads.
    private final ThreadGroup counterGroup = new ThreadGroup("counters");
}
